Index: locale/en/mlx.po
===================================================================
--- locale/en/mlx.po	(revision 384)
+++ locale/en/mlx.po	(revision 391)
@@ -780,4 +780,10 @@
 msgstr "Enter the takeoff derate parameter."
 
+msgid "takeoff_antiice"
+msgstr "Anti-i_ce system on"
+
+msgid "takeoff_antiice_tooltip"
+msgstr "Indicate if you have turned on or off the anti-ice system of your aircraft before takeoff. If your aircraft indicates the status of the anti-ice system towards the logger correctly, this checkbox will be handled automatically, though you can still override it later, and it will be reflected in the log."
+
 msgid "takeoff_rto"
 msgstr "R_ejected takeoff"
@@ -858,4 +864,10 @@
 msgid "landing_vref_tooltip_kmph"
 msgstr "The landing reference speed in km/h."
+
+msgid "landing_antiice"
+msgstr "Anti-i_ce system on"
+
+msgid "landing_antiice_tooltip"
+msgstr "Indicate if you have turned on or off the anti-ice system of your aircraft before landing. If your aircraft indicates the status of the anti-ice system towards the logger correctly, this checkbox will be handled automatically, though you can still override it later, and it will be reflected in the log."
 
 msgid "flighttype_scheduled"
Index: locale/hu/mlx.po
===================================================================
--- locale/hu/mlx.po	(revision 388)
+++ locale/hu/mlx.po	(revision 391)
@@ -781,4 +781,10 @@
 msgstr "Írd be a felszállási teljesítménycsökkentés értékét."
 
+msgid "takeoff_antiice"
+msgstr "Jé_gtelenítés bekapcsolva"
+
+msgid "takeoff_antiice_tooltip"
+msgstr "Itt jelezheted, hogy a repülőgép jégtelenítő rendszerét bekapcsoltad felszállás előtt. Ha a repülőgép megfelelően jelzi a jégtelenítő rendszer állapotát a logger felé, ezt a jelölődobozt a program automatikusan kezeli. A kijelölést a későbbiek során szabadon módosíthatod, ami a logban is megjelenik."
+
 msgid "takeoff_rto"
 msgstr "_Megszakított felszállás"
@@ -859,4 +865,10 @@
 msgid "landing_vref_tooltip_kmph"
 msgstr "A leszállási sebesség km/órában."
+
+msgid "landing_antiice"
+msgstr "Jé_gtelenítés bekapcsolva"
+
+msgid "landing_antiice_tooltip"
+msgstr "Itt jelezheted, hogy a repülőgép jégtelenítő rendszerét bekapcsoltad leszállás előtt. Ha a repülőgép megfelelően jelzi a jégtelenítő rendszer állapotát a logger felé, ezt a jelölődobozt a program automatikusan kezeli. A kijelölést a későbbiek során szabadon módosíthatod, ami a logban is megjelenik."
 
 msgid "flighttype_scheduled"
Index: src/mlx/acft.py
===================================================================
--- src/mlx/acft.py	(revision 384)
+++ src/mlx/acft.py	(revision 391)
@@ -76,5 +76,7 @@
         self._v1r2LineIndex = None
         self._derateLineID = None
+        self._takeoffAntiIceLineID = None
         self._vrefLineIndex = None
+        self._landingAntiIceLineID = None
 
         self.humanWeight = 82.0
@@ -294,4 +296,5 @@
                 self._logV1R2(aircraftState)
                 self._logDerate(aircraftState)
+                self._logTakeoffAntiIce(aircraftState)
             elif newStage==const.STAGE_DESCENT or newStage==const.STAGE_LANDING:
                 self._logRadios(aircraftState)
@@ -351,4 +354,5 @@
                             (self._aircraftState.altimeter,))
         self._logVRef()
+        self._logLandingAntiIce(self._aircraftState)
         self.flight.flareStarted(flareStart, flareStartFS)
         fs.sendMessage(const.MESSAGETYPE_INFORMATION, "Flare-time", 3)
@@ -409,4 +413,9 @@
             self._logDerate()
 
+    def updateTakeoffAntiIce(self):
+        """Update the take-off anti-ice setting."""
+        if self._takeoffAntiIceLineID is not None:
+            self._logTakeoffAntiIce()
+
     def _appendLightsLoggers(self):
         """Append the loggers needed for the lights.
@@ -475,4 +484,23 @@
         else:
             self.logger.updateLine(self._derateLineID, message)
+
+    def _logTakeoffAntiIce(self, state = None):
+        """Log the take-off anti-ice setting either newly or by updating the
+        corresponding line."""
+        antiIceOn = self._flight.takeoffAntiIceOn
+        if state is not None:
+            antiIceOn = antiIceOn or state.antiIceOn is True
+            self._flight.takeoffAntiIceOn = antiIceOn
+
+        message = "Anti-ice was turned %s" % \
+                  ("ON" if antiIceOn else "OFF")
+
+        if self._takeoffAntiIceLineID is None:
+            if state is None:
+                state = self._aircraftState
+            self._takeoffAntiIceLineID = \
+                self.logger.message(state.timestamp, message)
+        else:
+            self.logger.updateLine(self._takeoffAntiIceLineID, message)
 
     def updateVRef(self):
@@ -492,4 +520,28 @@
         else:
             self.logger.updateLine(self._vrefLineIndex, message)
+
+    def updateLandingAntiIce(self):
+        """Update the landing anti-ice setting."""
+        if self._landingAntiIceLineID is not None:
+            self._logLandingAntiIce()
+
+    def _logLandingAntiIce(self, state = None):
+        """Log the landing anti-ice setting either newly or by updating the
+        corresponding line."""
+        antiIceOn = self._flight.landingAntiIceOn
+        if state is not None:
+            antiIceOn = antiIceOn or state.antiIceOn is True
+            self._flight.landingAntiIceOn = antiIceOn
+
+        message = "Anti-ice was turned %s" % \
+                  ("ON" if antiIceOn else "OFF")
+
+        if self._landingAntiIceLineID is None:
+            if state is None:
+                state = self._aircraftState
+            self._landingAntiIceLineID = \
+                self.logger.message(state.timestamp, message)
+        else:
+            self.logger.updateLine(self._landingAntiIceLineID, message)
 
     def _fleetRetrieved(self, fleet):
Index: src/mlx/flight.py
===================================================================
--- src/mlx/flight.py	(revision 384)
+++ src/mlx/flight.py	(revision 391)
@@ -183,4 +183,14 @@
 
     @property
+    def takeoffAntiIceOn(self):
+        """Get whether the anti-ice system was on during takeoff."""
+        return self._gui.takeoffAntiIceOn
+
+    @takeoffAntiIceOn.setter
+    def takeoffAntiIceOn(self, value):
+        """Set whether the anti-ice system was on during takeoff."""
+        self._gui.takeoffAntiIceOn = value
+
+    @property
     def derate(self):
         """Get the derate value of the flight."""
@@ -211,4 +221,14 @@
         """Get the VRef speed of the flight."""
         return self._gui.vref
+
+    @property
+    def landingAntiIceOn(self):
+        """Get whether the anti-ice system was on during landing."""
+        return self._gui.landingAntiIceOn
+
+    @landingAntiIceOn.setter
+    def landingAntiIceOn(self, value):
+        """Set whether the anti-ice system was on during landing."""
+        self._gui.landingAntiIceOn = value
 
     @property
Index: src/mlx/gui/flight.py
===================================================================
--- src/mlx/gui/flight.py	(revision 384)
+++ src/mlx/gui/flight.py	(revision 391)
@@ -1999,5 +1999,5 @@
                                   xscale = 0.0, yscale = 0.0)
 
-        table = gtk.Table(7, 4)
+        table = gtk.Table(8, 4)
         table.set_row_spacings(4)
         table.set_col_spacings(16)
@@ -2102,9 +2102,14 @@
         table.attach(self._derateUnit, 3, 4, 5, 6)
 
+        self._antiIceOn = gtk.CheckButton(xstr("takeoff_antiice"))
+        self._antiIceOn.set_use_underline(True)
+        self._antiIceOn.set_tooltip_text(xstr("takeoff_antiice_tooltip"))
+        table.attach(self._antiIceOn, 2, 4, 6, 7)
+
         self._rto = gtk.CheckButton(xstr("takeoff_rto"))
         self._rto.set_use_underline(True)
         self._rto.set_tooltip_text(xstr("takeoff_rto_tooltip"))
         self._rto.connect("toggled", self._rtoToggled)
-        table.attach(self._rto, 2, 4, 6, 7, ypadding = 8)
+        table.attach(self._rto, 2, 4, 7, 8, ypadding = 8)
 
         self.addCancelFlightButton()
@@ -2147,4 +2152,14 @@
         else:
             return None
+
+    @property
+    def antiIceOn(self):
+        """Get whether the anti-ice system has been turned on."""
+        return self._antiIceOn.get_active()
+
+    @antiIceOn.setter
+    def antiIceOn(self, value):
+        """Set the anti-ice indicator."""
+        self._antiIceOn.set_active(value)
 
     @property
@@ -2213,6 +2228,6 @@
         self._vr.reset()
         self._v2.reset()
-
         self._hasDerate = False
+        self._antiIceOn.set_active(False)
 
     def setRTOEnabled(self, enabled):
@@ -2259,7 +2274,9 @@
     def _forwardClicked(self, button):
         """Called when the forward button is clicked."""
-        self._wizard.gui.flight.aircraft.updateV1R2()
+        aircraft = self._wizard.gui.flight.aircraft
+        aircraft.updateV1R2()
         if self._hasDerate:
-            self._wizard.gui.flight.aircraft.updateDerate()
+            aircraft.updateDerate()
+        aircraft.updateTakeoffAntiIce()
         self._wizard.nextPage()
 
@@ -2393,5 +2410,5 @@
                                   xscale = 0.0, yscale = 0.0)
 
-        table = gtk.Table(5, 5)
+        table = gtk.Table(6, 5)
         table.set_row_spacings(4)
         table.set_col_spacings(16)
@@ -2462,5 +2479,5 @@
         label.set_use_underline(True)
         label.set_alignment(0.0, 0.5)
-        table.attach(label, 1, 2, 5, 6)
+        table.attach(label, 1, 2, 4, 5)
 
         self._vref = IntegerEntry()
@@ -2468,9 +2485,14 @@
         self._vref.set_tooltip_markup(xstr("landing_vref_tooltip_knots"))
         self._vref.connect("integer-changed", self._vrefChanged)
-        table.attach(self._vref, 3, 4, 5, 6)
+        table.attach(self._vref, 3, 4, 4, 5)
         label.set_mnemonic_widget(self._vref)
 
         self._vrefUnit = gtk.Label(xstr("label_knots"))
-        table.attach(self._vrefUnit, 4, 5, 5, 6)
+        table.attach(self._vrefUnit, 4, 5, 4, 5)
+
+        self._antiIceOn = gtk.CheckButton(xstr("landing_antiice"))
+        self._antiIceOn.set_use_underline(True)
+        self._antiIceOn.set_tooltip_text(xstr("landing_antiice_tooltip"))
+        table.attach(self._antiIceOn, 3, 5, 5, 6)
 
         self.addCancelFlightButton()
@@ -2510,8 +2532,19 @@
         return self._vref.get_int()
 
+    @property
+    def antiIceOn(self):
+        """Get whether the anti-ice system has been turned on."""
+        return self._antiIceOn.get_active()
+
+    @antiIceOn.setter
+    def antiIceOn(self, value):
+        """Set the anti-ice indicator."""
+        self._antiIceOn.set_active(value)
+
     def reset(self):
         """Reset the page if the wizard is reset."""
         super(LandingPage, self).reset()
         self._vref.reset()
+        self._antiIceOn.set_active(False)
         self._flightEnded = False
 
@@ -2595,5 +2628,7 @@
     def _forwardClicked(self, button):
         """Called when the forward button is clicked."""
-        self._wizard.gui.flight.aircraft.updateVRef()
+        aircraft = self._wizard.gui.flight.aircraft
+        aircraft.updateVRef()
+        aircraft.updateLandingAntiIce()
         if self._wizard.gui.config.onlineGateSystem and \
            self._wizard.loggedIn and not self._completed and \
@@ -3187,4 +3222,14 @@
 
     @property
+    def takeoffAntiIceOn(self):
+        """Get whether the anti-ice system was on during take-off."""
+        return self._takeoffPage.antiIceOn
+
+    @takeoffAntiIceOn.setter
+    def takeoffAntiIceOn(self, value):
+        """Set anti-ice on indicator."""
+        self._takeoffPage.antiIceOn = value
+
+    @property
     def rtoIndicated(self):
         """Get whether the pilot has indicated that an RTO has occured."""
@@ -3215,4 +3260,14 @@
         """Get the Vref speed."""
         return self._landingPage.vref
+
+    @property
+    def landingAntiIceOn(self):
+        """Get whether the anti-ice system was on during landing."""
+        return self._landingPage.antiIceOn
+
+    @landingAntiIceOn.setter
+    def landingAntiIceOn(self, value):
+        """Set anti-ice on indicator."""
+        self._landingPage.antiIceOn = value
 
     @property
Index: src/mlx/gui/gui.py
===================================================================
--- src/mlx/gui/gui.py	(revision 384)
+++ src/mlx/gui/gui.py	(revision 391)
@@ -313,4 +313,14 @@
 
     @property
+    def takeoffAntiIceOn(self):
+        """Get whether the anti-ice system was on during take-off."""
+        return self._wizard.takeoffAntiIceOn
+
+    @takeoffAntiIceOn.setter
+    def takeoffAntiIceOn(self, value):
+        """Set the anti-ice on indicator."""
+        gobject.idle_add(self._setTakeoffAntiIceOn, value)
+
+    @property
     def rtoIndicated(self):
         """Get whether the pilot has indicated than an RTO has occured."""
@@ -341,4 +351,14 @@
         """Get the Vref speed calculated for the flight."""
         return self._wizard.vref
+
+    @property
+    def landingAntiIceOn(self):
+        """Get whether the anti-ice system was on during landing."""
+        return self._wizard.landingAntiIceOn
+
+    @landingAntiIceOn.setter
+    def landingAntiIceOn(self, value):
+        """Set the anti-ice on indicator."""
+        gobject.idle_add(self._setLandingAntiIceOn, value)
 
     @property
@@ -1438,2 +1458,10 @@
         """Show the about URL."""
         webbrowser.open(url = link, new = 1)
+
+    def _setTakeoffAntiIceOn(self, value):
+        """Set the anti-ice on indicator."""
+        self._wizard.takeoffAntiIceOn = value
+
+    def _setLandingAntiIceOn(self, value):
+        """Set the anti-ice on indicator."""
+        self._wizard.landingAntiIceOn = value
Index: test/test1.txt
===================================================================
--- test/test1.txt	(revision 375)
+++ test/test1.txt	(revision 391)
@@ -17,4 +17,6 @@
 set n1_2=25
 set pitot=yes
+set eng1Deice=yes
+set eng2Deice=yes
 set gs=10 ias=10
 set flapsControl=37.5