Index: MLXMANIFEST
===================================================================
--- MLXMANIFEST	(revision 595)
+++ MLXMANIFEST	(revision 603)
@@ -7,5 +7,5 @@
 library/fnmatch.pyc	3414	4d50000f78e903598af06ef1c5cfb3ef
 library/libexpat-1.dll	143096	701659d3689bf4a8265b669b7d774255
-library/gtk/_gtk.pyc	549	2abfca0977d3579e02729d232c120716
+library/gtk/_gtk.pyc	549	4ecffec81c11e7800ac7491c0500b140
 library/encodings/cp858.pyc	7591	02054a0b8e91b9758826eb70cddf096f
 library/mlx/pirep.pyc	4623	6c485ea65ff6245ab56960a8bbec7051
@@ -22,5 +22,5 @@
 doc/manual/hu/bugreport.png	12385	c71c7db56f19870ae5d6bb7f533d3679
 library/share/locale/hu/LC_MESSAGES/gtk20.mo	58794	6ee4491ae7bc9d3dfb778578eb29a0b3
-library/gobject/_gobject.pyc	573	88aa2543c3a34d7d0e5e688c5dda3130
+library/gobject/_gobject.pyc	573	b303d1a23fddb47a507970e9bafeedb4
 locale/en/LC_MESSAGES/mlx.mo	64274	02be765dc85cd05ef6f28aae2befa46c
 library/encodings/utf_7.pyc	1747	2beeb059236527197d6c640396476ce8
@@ -76,10 +76,10 @@
 library/_hashlib.pyd	287232	a1a18de0644f481749fcbcf26005eeaf
 doc/manual/en/monitorWindow.png	20886	42e08d10c758e21209c4c021f391dee7
-library/_hashlib.pyc	549	f527bf68967e9a2015c208ea5d5c9032
+library/_hashlib.pyc	549	cf9d8f468e261035e7d71ea3c276ae64
 library/libpng14-14.dll	230529	f3a15497e25baaa721f96638d7a4d2f8
 library/copy.pyc	11674	30d1745c5e38ab170f8a0486fbebf305
 library/share/locale/hu/LC_MESSAGES/gdk-pixbuf.mo	21895	a932ead453f04de30e348c1689a4d896
-library/mlx/gui/dcdata.pyc	16051	7a7f655725cae055fc5047374e05f73a
-library/mlx/gui/__init__.pyc	107	22f268cac1c5be2f3a058810b6caead3
+library/mlx/gui/dcdata.pyc	19878	128e72fd5c4cf74b988abe22b9e9e641
+library/mlx/gui/__init__.pyc	107	3494fc6a671a7b8a9dc72ea93948ae52
 library/encodings/iso8859_5.pyc	2679	58a290e94b0266ef8ff4ee52da00e257
 library/encodings/iso2022_kr.pyc	1683	ef9549932514d2deda6c4676e5e5f1db
@@ -137,6 +137,6 @@
 doc/manual/en/prefsAdvanced.png	16169	64c14e0842c413cac98b92926279f3e0
 library/mlx/pyuipc_sim.pyc	57183	b201f4d4c95d9c27a847fdd9a57b17a1
-library/cairo/_cairo.pyc	561	94f0ea755373c60b1a6fc2540b23e346
-library/win32file.pyc	552	8c7f15456649ee5e3fb8979c581a6ecb
+library/cairo/_cairo.pyc	561	0289736f8a93dad30fd32ffa2845d37e
+library/win32file.pyc	552	9f5af482e5752c6c1a1bc6bbb5628ede
 library/encodings/cp865.pyc	7868	7d40a7ba053ac23339218be8799e5397
 library/lib/gtk-2.0/2.10.0/engines/libwimp.dll	97984	a5bbbe46e1363aba9020a76f2d58e9d6
@@ -148,5 +148,5 @@
 library/share/locale/hu/LC_MESSAGES/gtk20-properties.mo	167125	cd1b1b3693c1e3c74bfcea20be640cc6
 conn_red.png	914	860388cb7c3b26b2f348fdbee40780ce
-library/bz2.pyc	534	5917b89061d1a8cd04b169f3b1b14d20
+library/bz2.pyc	534	3f2f110b18bdaa15f75ea58706f1e503
 library/xml/sax/expatreader.pyc	13563	4f64c0efb2f1f8dbba84cdb5c6036f2d
 library/email/utils.pyc	8840	a7be428df6fddee6121cfce55382d1f8
@@ -164,6 +164,6 @@
 library/mlx/gui/statusbar.pyc	4812	799c3b2d6e3f85ecd79f68d5814d7c40
 library/warnings.pyc	12666	9788b5f45765e8204e04c820f2711094
-mlxupdate.exe	19456	e4835237ee185f26a0554c1edf236f82
-library/mlx/const.pyc	6707	19db1c42db58f727d587414ae1c58826
+mlxupdate.exe	19456	007f41609312aaded6ede94bb59e7b76
+library/mlx/const.pyc	6707	83693845ec8d9ba7829601f0af3adbf6
 library/email/errors.pyc	3229	cdb78ab237e195ad69f059128bc03b1d
 library/linecache.pyc	3091	666e6f81b0ea9a7637f8068493f738d5
@@ -178,5 +178,5 @@
 library/shlex.pyc	7282	cbe1a4823894c97c87d01f9d9faf5b8f
 library/cairo/__init__.pyc	142	010dd7cc8485565d5782d60e92e4ba34
-library/_ssl.pyc	537	44e917d8ec6d7f49c272667b5bc080ca
+library/_ssl.pyc	537	ca765d8f59038053846dd9d53ae1e8f6
 library/encodings/iso8859_8.pyc	2717	f3ad6ce58cfac9e3ca86cf5c2fef092b
 library/encodings/iso2022_jp_1.pyc	1699	faed9d5747e982cec9fa8b3ad8e1de26
@@ -198,6 +198,6 @@
 library/encodings/cp1252.pyc	2676	b4c43cc72650c911cf3654dbaf565df9
 library/share/locale/hu/LC_MESSAGES/atk10.mo	8465	e3f3466da367215aad971d7b0394229d
-library/unicodedata.pyc	558	4fcd340ca0a961d6ef64f447fb028674
-library/select.pyc	543	a15ec8cae61f22741a2a0d5364bd5aa4
+library/unicodedata.pyc	558	f625dc77c2d9ebb554515a60ee46dd0d
+library/select.pyc	543	a165c6c921c602cf2cf1b8de2301eb2c
 library/encodings/uu_codec.pyc	4646	5282a5fcb676851224d2924aa3e48a9e
 library/ConfigParser.pyc	23857	1d17020dd0000ce0f73de812effa152f
@@ -231,5 +231,5 @@
 doc/manual/hu/flightInfoTab.png	28786	3e8af27775131f02696b0912ca441f36
 library/encodings/utf_8_sig.pyc	4625	1b1405db186e5819fa271ff96c1ca2c5
-library/pangocairo.pyc	555	d9f7fbcf68e8605901e53652bf48dfc6
+library/pangocairo.pyc	555	3a7edf04a9de15cf6412667ac4d57a24
 library/encodings/cp1255.pyc	2697	b265913c887f2e1c8736632b652c0093
 library/encodings/zlib_codec.pyc	4308	319c9073aff840436a03cc1fa0b08fb5
@@ -244,5 +244,5 @@
 library/intl.dll	152489	eb2d4c4d4a527bc88a69a16cc99afcf5
 library/encodings/mbcs.pyc	1883	2213911a7dd0deada6799b63e18b695b
-library/pyuipc.pyc	543	57863192a5717f2e486d38b3659dcc8c
+library/pyuipc.pyc	543	9dc5f14969c4801bc86071f5f779249f
 sounds/TOC.mp3	273032	fae1be2ad25c8b54806bd1d759919705
 library/encodings/iso8859_4.pyc	2678	16f2fe7994051752360c533c052b892b
@@ -268,11 +268,11 @@
 doc/manual/hu/flightSelection.png	30815	e8bcdda6079c6b16ffa72ca62c21ca85
 library/win32pipe.pyd	24064	de374eded459293b2a7eb8ed8fb38eaa
-library/win32pipe.pyc	552	826a48ebfc4f2782fff655121d8bb44e
+library/win32pipe.pyc	552	329a8ab802218d9962a247a89d51e22a
 doc/manual/hu/cruise.png	27460	a2610173563e45baae1b0f9e63007ebd
 doc/manual/hu/logTab.png	28706	f48004202310bd2a1cb2f873d8064e93
 library/encodings/iso2022_jp_2004.pyc	1723	66376e788f3819e781897268c1100986
-library/win32event.pyc	555	5af3c624b5a9011fd2a42bb505fa0808
+library/win32event.pyc	555	10f413529fa89817f31c0133e567684e
 library/encodings/cp866.pyc	8103	f36418dcf93b17b3ced63bd544f44159
-library/gio/_gio.pyc	549	fac856040ad20ac48466750e37f0f76a
+library/gio/_gio.pyc	549	c2e655da7e2dc845ec8e079fd6340224
 library/encodings/cp437.pyc	7874	63f1278c0a66129c6fb4f504d6b61b66
 doc/manual/hu/helpTab.png	27961	8e7cc4aeb8d7f40fcf186c7caf53583b
@@ -297,5 +297,5 @@
 library/mlx/gui/pirep.pyc	16749	2006126d65a19999a20c4a34f1e94342
 library/mimetypes.pyc	17806	927ce6a7079707aaee925e855ed23454
-library/_ctypes.pyc	546	b856ed67715eeeb4b568bd59b5c02326
+library/_ctypes.pyc	546	e30887dffc69e7ad968afa6961f87bcb
 sounds/F70taxi.mp3	154854	51332dc691d3519355f61ed06c959d8d
 library/encodings/cp857.pyc	7611	1b46c8959ac097b73e1c680d464cdc32
@@ -328,5 +328,5 @@
 library/unittest/case.pyc	37758	1d2235e74c246b562c5c00ddf73c621a
 library/subprocess.pyc	38648	c9f749db06dfc9fb32079de51d6efd01
-library/mlx/acft.pyc	36936	e6ea4fe0a45d251cd67f3749ee19a0af
+library/mlx/acft.pyc	37076	4e1cd783429ebc5911a44cddb0651ee7
 library/gobject._gobject.pyd	113152	3d05dd191361f83aa247b62c700fa04e
 doc/manual/hu/checklistEditor.png	27863	8c750892a52dc10ca654a9d0b2765358
@@ -342,5 +342,5 @@
 library/encodings/cp863.pyc	7868	fc7ff06dab536b93c68fcb8e7bac713f
 library/xml/parsers/__init__.pyc	294	83f6a77ed8cd962b3c75c4779dc557ac
-library/pyexpat.pyc	546	272078041aa987807cb3cb66432c64e8
+library/pyexpat.pyc	546	996c2912b4e19156f75975937b3a00bb
 doc/manual/hu/gateSelection.png	29237	bac37e7001261a40a84e4202247f6052
 library/cmd.pyc	13512	808f813d5e354b7073a1356e44c7b554
@@ -368,15 +368,15 @@
 library/_socket.pyd	38400	5d273be76603399e88cf57f2605004bf
 sounds/ding.wav	80856	18e639792d3767436ac6955eb60e4f54
-library/_socket.pyc	546	b606a126f613e567d31475f3d28cf5bc
+library/_socket.pyc	546	bd77e01b70f3c0feee7e6e1e972b1b65
 library/encodings/hex_codec.pyc	3520	a8b8d5b7c8810379c7007bcbc253951c
-library/mlx/checks.pyc	59537	530b9832280541cc78d7d20399d6d657
+library/mlx/checks.pyc	61059	4b49f11e0172686025afed2f5d52b09c
 doc/manual/en/statusIcon2.png	5875	71fc121823dee0a4c00715fac1b5665c
 library/mlx/sound.pyc	8226	03b098ed1dd965db98ef4f75b07d6cae
 doc/manual/en/pirepViewer.png	25098	7c545e70b995ac0f9fcae93fe5d0e899
 library/encodings/aliases.pyc	8750	75c22196420d0157fec085d285947a71
-library/glib/_glib.pyc	555	41063cd3f4dfcb1263ce4c0db6e711a5
+library/glib/_glib.pyc	555	a2621d975a29d2783b52d3ffc4a383c2
 library/libpangowin32-1.0-0.dll	108945	d07f128828225b7cc38e9e590eb3ba8a
 library/encodings/iso8859_10.pyc	2693	5e6cc8f721486ddbc1c99da285e13191
-library/win32api.pyc	549	1f6c2d94889d9952efbff618c17c511d
+library/win32api.pyc	549	59883ae826090fcbc4d08c851eccb485
 library/gobject/constants.pyc	1957	2e9cdc605e7c449ef4fc23f56128acec
 library/libgtk-win32-2.0-0.dll	4938115	cc6dca192aca6f91bd96a5b5f86e036d
@@ -399,5 +399,5 @@
 sounds/cpt_takeoff.mp3	8255	254edcf79b8b3752d1a7c191c57f615a
 library/encodings/cp860.pyc	7857	59c6f69108873700081e71b2faaa29f8
-library/mlx/__init__.pyc	103	029f80bd80f880e6ca70ef4ba46f7d06
+library/mlx/__init__.pyc	103	877b8715b7e58440a0e8f212cab6035e
 library/encodings/iso8859_13.pyc	2696	f901ae0bbcfbb78f0c1783e89b2e2dc5
 library/mlx/i18n.pyc	1972	fe45816e49cf5e380bc39942a9dfa875
@@ -426,5 +426,5 @@
 library/glib._glib.pyd	58368	0de636503e43c4eb00e80927bc9bda97
 library/mlx/config.pyc	30521	75c1c4c91c71e1a7f486a54b4f32b6a0
-library/atk.pyc	534	8982e2d75dbd506a8f70853142545159
+library/atk.pyc	534	9082e470d7326f8aef3123260ebf20eb
 library/gio._gio.pyd	263168	acb8c95fdc391079bebdf7d8685b0dbc
 library/encodings/cp861.pyc	7868	c97a8970ce4d9f40cbafbea6576fbdca
@@ -436,5 +436,5 @@
 library/__future__.pyc	4177	43d264d951ac2085334c7b9dd4558595
 library/logging/__init__.pyc	54813	7bcdf2e8da474f5e94d8e499f6fc3ed4
-runmlx.exe	64000	c2fccb01f52efe5aff9848a4b9226b24
+runmlx.exe	64000	7ca38a463ccc6b3a83fe06ca37045e01
 library/optparse.pyc	51253	39594a40bc1222173d57b7d5740e3d92
 library/mlx/fs.pyc	11803	199bdac7de7a006e762f12563e08c6e0
@@ -449,5 +449,5 @@
 library/glib/option.pyc	11891	bd90183c75d8f473ecf653e3d63a27f9
 library/StringIO.pyc	11100	f4eb4a2bb3d6fb0af925681c5375c673
-library/pango.pyc	540	39147d60226aa3669bb94e1f41b1e04c
+library/pango.pyc	540	ac6e3411f1cb5beb13a7eada3e18558d
 Microsoft.VC90.CRT/msvcp90.dll	568832	6de5c66e434a9c1729575763d891c6c2
 library/sre_parse.pyc	18380	fe2376a101668be1124f9ee316662bab